
_readSensor:

;Stretch.mbas,48 :: 		sub procedure readSensor()
;Stretch.mbas,49 :: 		adc_rd = ADC_Get_Sample(7)                ' Read PA7
	PUSH       R2
	LDI        R27, 7
	MOV        R2, R27
	CALL       _ADC_Get_Sample+0
	STS        _adc_rd+0, R16
;Stretch.mbas,50 :: 		delay_ms(10)                              ' Pause 10ms
	LDI        R17, 104
	LDI        R16, 229
L__readSensor1:
	DEC        R16
	BRNE       L__readSensor1
	DEC        R17
	BRNE       L__readSensor1
;Stretch.mbas,51 :: 		end sub
L_end_readSensor:
	POP        R2
	RET
; end of _readSensor

_set_adc:

;Stretch.mbas,56 :: 		sub procedure set_adc()
;Stretch.mbas,57 :: 		DDA7_bit = 0                              ' Set PA7 as input
	IN         R27, DDA7_bit+0
	CBR        R27, BitMask(DDA7_bit+0)
	OUT        DDA7_bit+0, R27
;Stretch.mbas,58 :: 		end sub
L_end_set_adc:
	RET
; end of _set_adc

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 14
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;Stretch.mbas,60 :: 		main:
;Stretch.mbas,61 :: 		set_adc()                                 ' Set A/D register
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	CALL       _set_adc+0
;Stretch.mbas,62 :: 		LCD_Init()                                ' Initialize Lcd
	CALL       _Lcd_Init+0
;Stretch.mbas,63 :: 		Lcd_Cmd(_LCD_CLEAR)                       ' Clear display
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;Stretch.mbas,64 :: 		Lcd_Cmd(_LCD_CURSOR_OFF)                  ' Cursor off
	LDI        R27, 12
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;Stretch.mbas,65 :: 		Lcd_Out(1,1,"Stretch click")              ' Write text in first row
	MOVW       R30, R28
	LDI        R27, 83
	ST         Z+, R27
	LDI        R27, 116
	ST         Z+, R27
	LDI        R27, 114
	ST         Z+, R27
	LDI        R27, 101
	ST         Z+, R27
	LDI        R27, 116
	ST         Z+, R27
	LDI        R27, 99
	ST         Z+, R27
	LDI        R27, 104
	ST         Z+, R27
	LDI        R27, 32
	ST         Z+, R27
	LDI        R27, 99
	ST         Z+, R27
	LDI        R27, 108
	ST         Z+, R27
	LDI        R27, 105
	ST         Z+, R27
	LDI        R27, 99
	ST         Z+, R27
	LDI        R27, 107
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
	MOVW       R16, R28
	MOVW       R4, R16
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Stretch.mbas,67 :: 		ADC_Init()                                ' Initialize ADC
	CALL       _ADC_Init+0
;Stretch.mbas,68 :: 		delay_ms(100)                             ' Pause of 100ms for ADC module stabilization
	LDI        R18, 5
	LDI        R17, 15
	LDI        R16, 242
L__main5:
	DEC        R16
	BRNE       L__main5
	DEC        R17
	BRNE       L__main5
	DEC        R18
	BRNE       L__main5
;Stretch.mbas,70 :: 		while TRUE
L__main8:
;Stretch.mbas,71 :: 		readSensor()                          ' Read sensor
	CALL       _readSensor+0
;Stretch.mbas,72 :: 		WordToStr(adc_rd,txt)                 ' Conversion int adc_rd to string txt
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDS        R2, _adc_rd+0
	LDI        R27, 0
	MOV        R3, R27
	CALL       _WordToStr+0
;Stretch.mbas,73 :: 		LCD_Out(2,4,txt)                      ' Print txt value on LCD
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDI        R27, 4
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Stretch.mbas,74 :: 		delay_ms(500)                         ' Pause 500ms
	LDI        R18, 21
	LDI        R17, 75
	LDI        R16, 191
L__main12:
	DEC        R16
	BRNE       L__main12
	DEC        R17
	BRNE       L__main12
	DEC        R18
	BRNE       L__main12
	NOP
;Stretch.mbas,75 :: 		wend
	JMP        L__main8
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
